;;; fuelle-2.scm
; Schritt 2 zum einfachen Containerladeproblem:
; erst den Erfolgsfall testen

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((exakt-voll? container)   ; erst Erfolgsfall pruefen
     container)
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    (else
     'undefiniert)
    ))

;;; ==> wir brauchen dazu:
; ----- exakt-voll? -----
; prueft, ob der Container vollstaendig gefuellt ist
; (Praedikat container -> boolean)
(define
  (exakt-voll? container)
  ; muss entwickelt werden!
  #f)
;;;---------------------------------------------
; Container sind Listen mit der Groesse am Kopf
(define (erzeuge-container groesse)
  (list groesse))

;;; ----- globale Variable fuer Testzwecke -----
(define
  *container*
  (erzeuge-container 80))
; ----- Alternative -----
;  (erzeuge-container 100))

(define
  *stuecke*
  (list 30 30 30 30 20 20 20 20))

;;; ----- Test -----
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))
